import math
from axelrod.action import Action
from axelrod.player import Player
IIlIlIIIllIIIIl, lIIIlllI = Action.C, Action.D
class IlIlIllllIlIII(Player):
    IllIllllIlIIlIIlIII = {
        "stochastic": False,
        "memory_depth": float("inf"),  
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def lIIIIlIIIIllIIl(IIIlIlIllIIlIIIIIl, lIllIIlllllI: Player) -> Action:
        if len(lIllIIlllllI.history) == 0:
            return IIlIlIIIllIIIIl
        if not lIllIIlllllI.llllIIllIIIIllI:
            return lIIIlllI
        IlIIlIlIIIll = lIllIIlllllI.IlIIlIlIIIll + IIIlIlIllIIlIIIIIl.IlIIlIlIIIll
        llllIIllIIIIllI = lIllIIlllllI.llllIIllIIIIllI + IIIlIlIllIIlIIIIIl.llllIIllIIIIllI
        if IlIIlIlIIIll / llllIIllIIIIllI > IIIlIlIllIIlIIIIIl.ratio:
            return lIIIlllI
        return IIlIlIIIllIIIIl